/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: avalon_timer.h 89 2009-01-25 16:02:00Z ertl-honda $
 */

/*
 *  ޥɥ饤СAvalon Timerѡ
 */

#ifndef TOPPERS_AVALON_TIMER_H
#define TOPPERS_AVALON_TIMER_H

#include <sil.h>

/*
 *  Avalon Timer ϡɥ
 */

/*
 *  쥸
 */
#define AVALON_TIM_STATUS    0x00
#define AVALON_TIM_CONTROL   0x04
#define AVALON_TIM_PERIODL   0x08
#define AVALON_TIM_PERIODH   0x0C
#define AVALON_TIM_SNAPL     0x10
#define AVALON_TIM_SNAPH     0x14

/*
 *  ӥå
 */
#define AVALON_TIM_STATUS_RUN 0x02
#define AVALON_TIM_STATUS_TO  0x01

#define AVALON_TIM_CONTROL_STOP  0x08
#define AVALON_TIM_CONTROL_START 0x04
#define AVALON_TIM_CONTROL_COUNT 0x02
#define AVALON_TIM_CONTROL_ITO   0x01


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͥ륿ޤΥ١ɥ쥹μơ֥
 *  åȰ¸ 
 */
extern const uint32_t target_sys_clk_timer_base_table[];

/*
 *  ͥ륿ޤγֹμơ֥
 *  åȰ¸ 
 */
extern const uint32_t target_sys_clk_timer_intno_table[];

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TO_CLOCK(nume, deno)    ((CLOCK)(TIMER_CLOCK * (nume) / (deno)))
#define TO_USEC(clock)          (((SYSUTM) clock) * 1000U / TIMER_CLOCK)

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK    ((CLOCK) 0xffffffffU)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void target_timer_terminate(intptr_t exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
	CLOCK count;
	uint32_t base = target_sys_clk_timer_base_table[x_prc_index()];

	/* ʥåץ쥸˽񤭹ͤۡɤ */
	sil_wrw_iop((void*)(base + AVALON_TIM_SNAPL), 0x00);

	/* ͤɤ߹ */
	count = sil_rew_iop((void*)(base + AVALON_TIM_SNAPL));
	count |= sil_rew_iop((void*)(base + AVALON_TIM_SNAPH)) << 16;
    
	return(TO_CLOCK(TIC_NUME, TIC_DENO) - count);
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
	uint32_t base = target_sys_clk_timer_base_table[x_prc_index()];
	return(sil_rew_iop((void*)(base + AVALON_TIM_STATUS)) & AVALON_TIM_STATUS_TO);
}

/*
 *  ޳ߥϥɥ
 */
extern void target_timer_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_AVALON_TIMER_H */
